<?php
/**
 * Troll base inclusion file.
 *
 * $Horde: troll/lib/base.php,v 1.49 2004/10/19 00:46:15 chuck Exp $
 *
 * This file brings in all of the dependencies that every Troll script
 * will need, and sets up objects that all scripts use.
 */

// Check for a prior definition of HORDE_BASE (perhaps by an
// auto_prepend_file definition for site customization).
if (!defined('HORDE_BASE')) {
    @define('HORDE_BASE', dirname(__FILE__) . '/../..');
}

// Load the Horde Framework core, and set up inclusion paths.
require_once HORDE_BASE . '/lib/core.php';

// Registry.
$registry = &Registry::singleton();
if (is_a(($pushed = $registry->pushApp('troll', !defined('AUTH_HANDLER'))), 'PEAR_Error')) {
    if ($pushed->getCode() == 'permission_denied') {
        Horde::authenticationFailureRedirect();
    }
    Horde::fatal($pushed, __FILE__, __LINE__, false);
}
$conf = &$GLOBALS['conf'];
@define('TROLL_TEMPLATES', $registry->get('templates'));

// Notification system.
$notification = &Notification::singleton();
$notification->attach('status');

// Find the base file path of Troll.
@define('TROLL_BASE', dirname(__FILE__) . '/..');

// Troll base libraries.
require_once TROLL_BASE . '/lib/Troll.php';

// Help.
require_once 'Horde/Help.php';

// Start compression, if requested.
Horde::compressOutput();

// Load the storage driver.
require_once TROLL_BASE . '/lib/Driver.php';
$backend = Troll::getBackend();
$GLOBALS['troll_driver'] = &Troll_driver::singleton($backend['driver'], Auth::getAuth(), $backend['params']);

// Create the troll session here.
if (!isset($_SESSION['troll']) || !is_array($_SESSION['troll'])) {
    $_SESSION['troll'] = array();
    $_SESSION['troll']['showall'] = true;
}

// Catch c-client errors.
register_shutdown_function('imap_errors');
