<?php
/**
 * $Horde: troll/lib/prefs.php,v 1.2 2005/01/03 14:35:35 jan Exp $
 *
 * Copyright 2002-2005 Thierry Thomas <thierry@pompo.net>
 * [from a duplication of imp/prefs.php
 *  Copyright 1999-2005 Charles J. Hagenbuch <chuck@horde.org>
 *  Copyright 1999-2005 Jon Parise <jon@horde.org>]
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

function handle_identityselect($updated)
{
    global $prefs;

    $default_identity = Util::getFormData('default_identity');
    if (!is_null($default_identity)) {
        $identities = @unserialize($prefs->getValue('identities'));
        if ($identities && count($identities) > 0 && isset($identities[$default_identity])) {
            if (!isset($prefs->prefs['default_identity'])) {
                $acl = 0;
                if ($prefs->isLocked('identities')) {
                    $acl |= _PREF_LOCKED;
                }
                if ($prefs->isShared('identities')) {
                    $acl |= _PREF_SHARED;
                }
                $prefs->add('default_identity', '', $acl);
            }
            $prefs->setValue('default_identity', $default_identity);
            if (!$prefs->isLocked('fullname')) {
                $prefs->setValue('fullname', $identities[$default_identity]['fullname']);
            }
            if (!$prefs->isLocked('from_addr')) {
                $prefs->setValue('from_addr', $identities[$default_identity]['from_addr']);
            }
            if (!$prefs->isLocked('replyto_addr')) {
                $prefs->setValue('replyto_addr', $identities[$default_identity]['replyto_addr']);
            }
            if (!$prefs->isLocked('signature')) {
                $prefs->setValue('signature', $identities[$default_identity]['signature']);
            }
            if (!$prefs->isLocked('sig_dashes')) {
                $prefs->setValue('sig_dashes', $identities[$default_identity]['sig_dashes']);
            }
            if (!$prefs->isLocked('sig_first')) {
                $prefs->setValue('sig_first', $identities[$default_identity]['sig_first']);
            }
            $updated = true;
        }
    }
    return $updated;
}
