<?php
/**
 * $Horde: troll/view.php,v 1.10 2005/01/03 14:35:35 jan Exp $
 *
 * Copyright 1999-2005 Charles J. Hagenbuch <chuck@horde.org>
 * Copyright 1999-2005 Jon Parise <jon@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

define('TROLL_BASE', dirname(__FILE__));
require_once TROLL_BASE . '/lib/base.php';
require_once TROLL_BASE . '/lib/MIME/Contents.php';

$actionID = Util::getFormData('actionID');
$index = Util::getFormData('index');

$troll_contents = &new Troll_Contents($index, Util::getFormData('mimecache'));

// TODO: Implement 'save_message' and 'view_source'
if (($actionID != 'save_message') && ($actionID != 'view_source')) {
    $mime = $troll_contents->getDecodedMIMEPart(Util::getFormData('id'));
    $body = $mime->getContents();
}

/* Run through action handlers */
switch ($actionID) {
case 'download_attach':
case 'download_render':
    if ($actionID == 'download_render') {
        $body = $troll_contents->renderMIMEPart($mime);
    }
    $browser->downloadHeaders($mime->getName(true), null, false, strlen($body));
    echo $body;
    exit;

case 'view_attach':
    $body = $troll_contents->renderMIMEPart($mime);
    $browser->downloadHeaders($mime->getName(true), $troll_contents->getMIMEViewerType($mime), true, strlen($body));
    echo $body;
    exit;

case 'view_source':
    require_once TROLL_BASE . '/lib/Headers.php';
    $troll_headers = &new Troll_Headers($index);
    $msg = $troll_headers->getHeaderText() . $troll_contents->getBody();
    $browser->downloadHeaders('Message Source', 'text/plain', true, strlen($msg));
    echo $msg;
    exit;

case 'save_message':
    require_once TROLL_BASE . '/lib/Headers.php';
    $troll_headers = &new Troll_Headers($index);

    $name = 'save_message';
    if (($subject = $troll_headers->getOb('subject', true))) {
        $name = preg_replace('|\W|', '_', $subject);
    }

    if (!($from = $troll_headers->getFromAddress())) {
        $from = '<>';
    }
    $date  = strftime('%a %b %d %H:%M:%S %Y', $troll_headers->getOb('udate'));
    $body  = 'From ' . $from . ' ' . $date. "\n";
    $body .= $troll_headers->getHeaderText();
    $body .= $troll_contents->getBody();
    $body  = str_replace("\r\n", "\n", $body);

    $browser->downloadHeaders($name, 'application/rfc822', false, strlen($body));
    echo $body;
    exit;
}
